//<editor-fold defaultstate="collapsed" desc=" COPYRIGHT AND LICENSE ">
/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.viewer3d.controls.light_editor;


import java.util.ArrayList;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import org.jogamp.java3d.BoundingSphere;
import org.visnow.vn.geometries.viewer3d.lights.DirectionalLightsFactory;
import org.visnow.vn.geometries.viewer3d.lights.EditableLight;
import org.visnow.vn.geometries.viewer3d.lights.EditablePointLight;
import org.visnow.vn.geometries.viewer3d.lights.LightObject;
import org.visnow.vn.geometries.viewer3d.lights.PointLightObject;

/**
 *
 * @author know
 */
public class LightTypeEditorPanel extends javax.swing.JPanel
{

    private final LightsEditor parentPanel;
    private final EditableLight.LightType type;
    private final ArrayList<SingleLightEditor>editors = new ArrayList<>();
    private BoundingSphere bounds = null;
    /**
     * Creates new form LightTypeEditorPanel
     */
    public LightTypeEditorPanel(EditableLight.LightType type, LightsEditor parentPanel)
    {
        initComponents();
        this.type = type;
        this.parentPanel = parentPanel;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        GridBagConstraints gridBagConstraints;

        addLightButton = new JButton();
        jScrollPane1 = new JScrollPane();
        jPanel1 = new JPanel();
        editorsPanel = new JPanel();
        fillPanel = new JPanel();

        setBorder(BorderFactory.createTitledBorder("lights"));
        setLayout(new BorderLayout());

        addLightButton.setText("add light");
        addLightButton.setMaximumSize(new Dimension(93, 21));
        addLightButton.setMinimumSize(new Dimension(93, 21));
        addLightButton.setPreferredSize(new Dimension(93, 21));
        addLightButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                addLightButtonActionPerformed(evt);
            }
        });
        add(addLightButton, BorderLayout.PAGE_END);

        jPanel1.setLayout(new GridBagLayout());

        editorsPanel.setBorder(BorderFactory.createEtchedBorder());
        editorsPanel.setMinimumSize(new Dimension(100, 24));
        editorsPanel.setOpaque(false);
        editorsPanel.setPreferredSize(new Dimension(200, 24));
        editorsPanel.setLayout(new GridLayout(0, 1));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(editorsPanel, gridBagConstraints);

        fillPanel.setMinimumSize(new Dimension(1, 1));
        fillPanel.setPreferredSize(new Dimension(200, 10));

        GroupLayout fillPanelLayout = new GroupLayout(fillPanel);
        fillPanel.setLayout(fillPanelLayout);
        fillPanelLayout.setHorizontalGroup(fillPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 238, Short.MAX_VALUE)
        );
        fillPanelLayout.setVerticalGroup(fillPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 127, Short.MAX_VALUE)
        );

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(fillPanel, gridBagConstraints);

        jScrollPane1.setViewportView(jPanel1);

        add(jScrollPane1, BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void addLightButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_addLightButtonActionPerformed
    {//GEN-HEADEREND:event_addLightButtonActionPerformed
        addLightObject();
    }//GEN-LAST:event_addLightButtonActionPerformed

    public void addLightObject()
    {
        switch (type) {
        case DIRECTIONAL:
            addLightObject(DirectionalLightsFactory.createLight(editors.size(), bounds));
            break;
        case POINT:
            addLightObject(new PointLightObject(new EditablePointLight(bounds, "point light " + editors.size())));
            break;
        }
    }

    public void addLightObject(LightObject newLight)
    {
        newLight.setEnabled(true);
        SingleLightEditor editor = new SingleLightEditor(newLight, parentPanel);
        int w = editorsPanel.getWidth();
        editor.setLightObject(newLight);
        editors.add(editor);
        parentPanel.addEditor(editor);
        Dimension d = new Dimension(w, 24 * editors.size());
        editorsPanel.setMinimumSize(d);
        editorsPanel.setMaximumSize(d);
        editorsPanel.setPreferredSize(d);
        editorsPanel.setSize(d);
        editorsPanel.add(editor);
        repaint();
        revalidate();
    }

    public void setBounds(BoundingSphere bounds)
    {
        this.bounds = bounds;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JButton addLightButton;
    private JPanel editorsPanel;
    private JPanel fillPanel;
    private JPanel jPanel1;
    private JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

}
